svn::Path Class Reference

`#include <path.hpp>`

## Public Member Functions

| Path (const std::string &path="")
| Path (const char *path)
| Path (const Path &path)
Path & | operator= (const Path &)
bool | operator== (const Path &) const
const std::string & | path () const
const char * | c_str () const
bool | isSet () const
bool | isUrl () const
void | addComponent (const char *component)
void | addComponent (const std::string &component)
void | split (std::string &dirpath, std::string &basename) const
void | split (std::string &dir, std::string &filename, std::string &ext) const
std::string | basename () const
std::string | dirpath () const
std::string | substr (const size_t index) const
std::string | unescape () const
size_t | length () const
std::string | native () const

## Static Public Member Functions

static Path | getTempDir ()

## Detailed Description

Encapsulation for Subversion Path handling

## Constructor & Destructor Documentation

svn::Path::Path | ( | const std::string & | path = `""` | ) |

Constructor that takes a string as parameter. The string is converted to subversion internal representation. The string is copied.

Parameters

  path | Path string

svn::Path::Path | ( | const char * | path | ) |

Constructor

See Also
  Path::Path (const std::string &)

Parameters

  path | Path string

svn::Path::Path | ( | const Path & | path | ) |

Copy constructor

Parameters

  path | Path to be copied

## Member Function Documentation

void svn::Path::addComponent | ( | const char * | component | ) |

adds a new URL component to the path

Parameters

  component | new component to add

void svn::Path::addComponent | ( | const std::string & | component | ) |

adds a new URL component to the path

Parameters

  component | new component to add

std::string svn::Path::basename | ( |  | ) | const

get a basename of a file

Returns
  basename filename without path

const char* svn::Path::c_str | ( |  | ) | const

Returns
  Path string as c string

std::string svn::Path::dirpath | ( |  | ) | const

get a name of directory containing file

Returns
  dirpath path of directory

static Path svn::Path::getTempDir | ( |  | ) |

static

returns the temporary directory

bool svn::Path::isSet | ( |  | ) | const

check whether a path is set. Right now this checks only if the string is non- empty.

Note
  This is the successor of isset which had to be removed since there was a name conflict with system headers on some systems (see issue 676)

Since
  0.12

Returns
  true if there is a path set

bool svn::Path::isUrl | ( |  | ) | const

shows whether we have a path or url

Returns
  true if the path is a valid url

size_t svn::Path::length | ( |  | ) | const

return the length of the path-string

std::string svn::Path::native | ( |  | ) | const

returns the path with native separators

Path& svn::Path::operator= | ( | const Path & |  | ) |

Assignment operator

bool svn::Path::operator== | ( | const Path & |  | ) | const

Comparison operator

const std::string& svn::Path::path | ( |  | ) | const

Returns
  Path string

void svn::Path::split | ( | std::string & | dirpath,
|  | std::string & | basename
| ) |  | const

split path in its components

Parameters

  dirpath | directory/path component
  basename | filename

void svn::Path::split | ( | std::string & | dir,
|  | std::string & | filename,
|  | std::string & | ext
| ) |  | const

split path in its components including file extension

Parameters

  dir | directory component
  filename | filename
  ext | extension (including leading dot ".")

std::string svn::Path::substr | ( | const size_t | index | ) | const

get a substring of a path, starting at index

Parameters

  index |

Returns
  substr substring

std::string svn::Path::unescape | ( |  | ) | const

return path as a string with unescaped special characters

Returns
  unescaped path

The documentation for this class was generated from the following file:

- path.hpp